MODULE definitions

   type structure
      integer,dimension(:),pointer::octree
      integer noctree,nnode,nleaves,nlsf
      double precision,dimension(:),pointer::x,y,z,forcex,forcey,forcez
      double precision,dimension(:,:),pointer:: lsf
      integer,dimension(:,:),pointer::icon
   end type structure

   type sheet
      integer nsurface
      double precision,dimension(:),pointer::r,s,x,y,z,xn,yn,zn
      integer nhull,levelt,itype,material
   end type sheet

END MODULE definitions


!------------------------------------------------------------------------------|
!------------------------------------------------------------------------------|
!                                                                              |
!              ||===\\                                                         | 
!              ||    \\                                                        |
!              ||     ||   //==\\   ||  ||   //==||  ||/==\\                   |
!              ||     ||  ||    ||  ||  ||  ||   ||  ||    ||                  |
!              ||    //   ||    ||  ||  ||  ||   ||  ||                        |
!              ||===//     \\==//    \\==\\  \\==\\  ||                        |
!                                                                              |
!------------------------------------------------------------------------------|
!------------------------------------------------------------------------------|
!                                                                              |
!              ROUTINE    Nov. 2006                                            |
!                                                                              |
!------------------------------------------------------------------------------|
!------------------------------------------------------------------------------|

program data_postprocessing

!------------------------------------------------------------------------------|
!(((((((((((((((( Purpose of the routine  ))))))))))))))))))))))))))))))))))))))
!------------------------------------------------------------------------------|

!------------------------------------------------------------------------------|
!(((((((((((((((( declaration of the subroutine internal variables )))))))))))))
!------------------------------------------------------------------------------|
use definitions

implicit none

type (sheet)::surface
type(structure),SAVE :: ov
integer :: ie,mer,nn,noc,ne,ner,i,i1,i2,i3,i4,i5,kfx,kfy,kfz,kft,iunit,ilsf,nne,is,k,npcl
double precision :: eps,dil,current_time,activation_time
logical,dimension(:),allocatable::influid
integer myicon(100),nstep,ndir,iter,istep
character clsf*3,c4*4,cc4*4,dir*128
character cs
character*4 cistep
character*2 citer


!------------------------------------------------------------------------------|
!------------------------------------------------------------------------------|

nne=8

print*,'Enter time step >'
read*,istep
print*,'Enter grid iteration >'
read*,iter

write(*,*) '**************************************************************************'
write(*,*) '--------------------------------------------------------------------------'
write(*,*) '--------------------------------------------------------------------------'
write(*,*) '------------------- VTK file production in progress ----------------------'
write(*,*) '--------------------------------------------------------------------------'
write(*,*) '--------------------------------------------------------------------------'

write(cistep,'(i4)') istep
if (istep.lt.1000) cistep(1:1)='0'
if (istep.lt.100) cistep(1:2)='00'
if (istep.lt.10) cistep(1:3)='000'

write (citer,'(i2)') iter
if (iter.lt.10) citer(1:1)='0'

open (unit=7,file='osolve_forces_'//cistep//'_'//citer//'.txt',status='old')
   

read (7,*) noc,ov%nnode,ne
nn=ov%nnode

allocate(ov%x(nn),ov%y(nn),ov%z(nn))
allocate(ov%forcex(nn),ov%forcey(nn),ov%forcez(nn))

write(*,'(a,i10)') 'octree length              ',noc
write(*,'(a,i10)') 'nb of nodes                ',ov%nnode
write(*,'(a,i10)') 'nb of leaves               ',ne

read(7,*)(ov%x(i),ov%y(i),ov%z(i),ov%forcex(i),ov%forcey(i),ov%forcez(i),i=1,nn)

write(*,'(a,2f35.20)') 'x      range : ',minval(ov%x(1:nn)),maxval(ov%x(1:nn))
write(*,'(a,2f35.20)') 'y      range : ',minval(ov%y(1:nn)),maxval(ov%y(1:nn))
write(*,'(a,2f35.20)') 'z      range : ',minval(ov%z(1:nn)),maxval(ov%z(1:nn))

write(*,*) 'forcex range : ',minval(ov%forcex(1:nn)),maxval(ov%forcex(1:nn))
write(*,*) 'forcey range : ',minval(ov%forcey(1:nn)),maxval(ov%forcey(1:nn))
write(*,*) 'forcez range : ',minval(ov%forcez(1:nn)),maxval(ov%forcez(1:nn))

! icon array
allocate(ov%icon(8,ne))
read(7,*) (ov%icon(1:8,ie),ie=1,ne)
ov%nleaves=ne 

! octree information
allocate(ov%octree(noc))
ov%noctree=noc
read(7,*) (ov%octree(i),i=1,noc)

close(7)


!------------------------------------------------------------------------------|
!------------------------------------------------------------------------------|

iunit=30
open(unit=iunit,file='forces.vtk')
write(iunit,'(a)')'# vtk DataFile Version 3.0'
write(iunit,'(a)')'velocities'
write(iunit,'(a)')'ASCII'
write(iunit,'(a)')'DATASET UNSTRUCTURED_GRID'
write(iunit,'(a7,i10,a6)')'POINTS ',nn,' float'

do i=1,nn
write(iunit,'(3f16.11)')ov%x(i),ov%y(i),ov%z(i)
enddo
write(iunit,'(A6, 2I10)') 'CELLS ',ne,(1+nne)*ne
do ie=1,ne
   myicon(1:nne)=ov%icon(1:nne,ie)-1
   write(iunit,'(9I10)')nne,myicon(1:nne)
enddo

write(iunit,'(A11, I10)') 'CELL_TYPES ',ne
do ie=1,ne
   write(iunit,'(I2)')11 ! octree  (8 nodes)
end do

write(iunit,'(a11,i10)')'POINT_DATA ',nn

   write(iunit,'(a)')'SCALARS force float 1'
   write(iunit,'(a)')'LOOKUP_TABLE default'
   do i=1,nn
      write(iunit,'(e11.4)') sqrt(ov%forcex(i)**2+ov%forcey(i)**2+ov%forcez(i)**2)
   enddo

write(iunit,'(a)')'VECTORS forcevect float'
do i=1,nn
   write(iunit,'(3e11.4)')ov%forcex(i),ov%forcey(i),ov%forcez(i)
enddo
   
!write(iunit,'(a)')'VECTORS forcex float'
!do i=1,nn
!   write(iunit,'(3f30.5)')ov%forcex(i),0.d0,0.d0
!enddo
!write(iunit,'(a)')'VECTORS forcey float'
!do i=1,nn
!   write(iunit,'(3f30.5)') 0.d0,ov%forcey(i),0.d0
!enddo
!write(iunit,'(a)')'VECTORS forcez float'
!do i=1,nn
!   write(iunit,'(3f30.5)') 0.d0,0.d0,ov%forcez(i)
!enddo

write(iunit,'(a)')'done visu.vtk'
close(iunit)


write(*,*) '--------------------------------------------------------------------------'
write(*,*)'opla I am done producing forces.vtk '
write(*,*) '--------------------------------------------------------------------------'
write(*,*) '**************************************************************************'

end
