program PlateGeometry
implicit none

double precision x0,y0,z0
double precision x1,y1,z1
double precision x2,y2,z2
double precision x3,y3,z3
double precision xne,yne,zne,x123,y123,z123

double precision xl,yl,zl
double precision dz,w,pi,wx,wy,dist,xyzn
integer nx,ny,nz,nnode,nnodemax,nelem,real_nelem,real_nnode
integer inode,ielem,i1,ij,k,i,j,i2,i3,ie

logical flag1,flag2,flag3,flag4,flag5,flag6,test
logical, dimension(:), allocatable :: yesno_point 

integer, dimension(:), allocatable :: effect_num

double precision,dimension(:),allocatable::x,y,z,xn,yn,zn,noise,real_x,real_y,real_z,real_xn,real_yn,real_zn
integer,dimension(:,:),allocatable::icon,real_icon
integer,dimension(:),allocatable::face

pi=atan(1.d0)*4.d0

!==============================================================================
!=====[user inputs]============================================================
!==============================================================================

x0=0.d0
y0=0.2d0
z0=0.d0

xl=0.8d0
yl=0.8d0
zl=0.111d0

nx=4
ny=8
nz=4

!flag1=.false.
flag1=.true.

!flag2=.false.
flag2=.true.

flag3=.false.
!flag3=.true.

flag4=.false.
!flag4=.true.

flag5=.false.
!flag5=.true.

flag6=.false.
!flag6=.true.

!      x0=0.4d0
!      y0=0.d0
!      z0=0.d0
!      xl=0.2d0
!      yl=0.2d0
!      zl=0.141d0
!      nx=64
!      ny=64
!      nz=32

!dz=0.d0
!      dz=.001d0
!      w=.2d0
!      wx=5.d0
!      wy=0.d0

!==============================================================================
!==============================================================================
!==============================================================================

write(*,'(a,f20.15)') 'x0=',x0
write(*,'(a,f20.15)') 'y0=',y0
write(*,'(a,f20.15)') 'z0=',z0
write(*,'(a,f20.15)') 'xl=',xl
write(*,'(a,f20.15)') 'yl=',yl
write(*,'(a,f20.15)') 'zl=',zl
write(*,'(a,i5)')     'nx=',nx
write(*,'(a,i5)')     'ny=',ny
write(*,'(a,i5)')     'nz=',nz

!==============================================================================
!==============================================================================
!==============================================================================

nnode=2*(nx*ny+ny*nz+nz*nx-2*(nx+ny+nz)+4)
nnodemax=2*(nx*ny+ny*nz+nz*nx)
allocate (x(nnodemax),y(nnodemax),z(nnodemax))
allocate (xn(nnodemax),yn(nnodemax),zn(nnodemax))
allocate (noise(nnodemax))

nelem=4*((nx-1)*(ny-1)+(ny-1)*(nz-1)+(nz-1)*(nx-1))
allocate (icon(3,nelem))

!=================================
!=====[place points in space]=====
!=================================

inode=0

!=====[x=x0]=====

do k=1,nz
   do j=1,ny
   inode=inode+1
   x(inode)=x0
   y(inode)=y0+yl*dble(j-1)/dble(ny-1)
   z(inode)=z0+zl*dble(k-1)/dble(nz-1)
   enddo
enddo

!=====[x=x0+xl]=====

do k=1,nz
   do j=1,ny
   inode=inode+1
   x(inode)=x0+xl
   y(inode)=y0+yl*dble(j-1)/dble(ny-1)
   z(inode)=z0+zl*dble(k-1)/dble(nz-1)
   enddo
enddo

!=====[y=y0]=====

do i=1,nx
   do k=1,nz
   inode=inode+1
   x(inode)=x0+xl*dble(i-1)/dble(nx-1)
   y(inode)=y0
   z(inode)=z0+zl*dble(k-1)/dble(nz-1)
   enddo
enddo

!=====[y=y0+yl]=====

do i=1,nx
   do k=1,nz
   inode=inode+1
   x(inode)=x0+xl*dble(i-1)/dble(nx-1)
   y(inode)=y0+yl
   z(inode)=z0+zl*dble(k-1)/dble(nz-1)
   enddo
enddo

!=====[z=z0]=====

do j=1,ny
   do i=1,nx
   inode=inode+1
   x(inode)=x0+xl*dble(i-1)/dble(nx-1)
   y(inode)=y0+yl*dble(j-1)/dble(ny-1)
   z(inode)=z0
   enddo
enddo

!=====[z=z0+zl]=====

do j=1,ny
   do i=1,nx
   inode=inode+1
   x(inode)=x0+xl*dble(i-1)/dble(nx-1)
   y(inode)=y0+yl*dble(j-1)/dble(ny-1)
   z(inode)=z0+zl
   enddo
enddo

nnode=inode

write(*,'(a,i6)') 'nb of created points',inode

write(*,'(a,3f20.15)') 'min(x),max(x)',minval(x),maxval(x),x0+xl
write(*,'(a,3f20.15)') 'min(y),max(y)',minval(y),maxval(y),y0+yl
write(*,'(a,3f20.15)') 'min(z),max(z)',minval(z),maxval(z),z0+zl
 

!=====[triangulate each face]===== 

allocate(face(nelem))

ielem=0

do j=1,ny-1
   do i=1,nx-1
      ielem=ielem+1
      face(ielem)=5
      icon(1,ielem)=(j-1)*nx+i
      icon(3,ielem)=icon(1,ielem)+1
      icon(2,ielem)=icon(1,ielem)+nx
      ielem=ielem+1
      face(ielem)=5
      icon(1,ielem)=icon(2,ielem-1)+1
      icon(3,ielem)=icon(2,ielem-1)
      icon(2,ielem)=icon(3,ielem-1)
   enddo
enddo

do j=1,ny-1
   do i=1,nx-1
      ielem=ielem+1
      face(ielem)=6
      icon(1,ielem)=nx*ny+(j-1)*nx+i
      icon(2,ielem)=icon(1,ielem)+1
      icon(3,ielem)=icon(1,ielem)+nx
      ielem=ielem+1
      face(ielem)=6
      icon(1,ielem)=icon(3,ielem-1)+1
      icon(2,ielem)=icon(3,ielem-1)
      icon(3,ielem)=icon(2,ielem-1)
   enddo
enddo


do k=1,nz-1
   do j=1,ny-1
      ielem=ielem+1
      face(ielem)=1
      icon(1,ielem)=2*nx*ny+(k-1)*ny+j
      icon(3,ielem)=icon(1,ielem)+1
      icon(2,ielem)=icon(1,ielem)+ny
      ielem=ielem+1
      face(ielem)=1
      icon(1,ielem)=icon(2,ielem-1)+1
      icon(3,ielem)=icon(2,ielem-1)
      icon(2,ielem)=icon(3,ielem-1)
   enddo
enddo

do k=1,nz-1
   do j=1,ny-1
      ielem=ielem+1
      face(ielem)=2
      icon(1,ielem)=2*nx*ny+ny*nz+(k-1)*ny+j
      icon(2,ielem)=icon(1,ielem)+1
      icon(3,ielem)=icon(1,ielem)+ny
      ielem=ielem+1
      face(ielem)=2
      icon(1,ielem)=icon(3,ielem-1)+1
      icon(2,ielem)=icon(3,ielem-1)
      icon(3,ielem)=icon(2,ielem-1)
   enddo
enddo

do i=1,nx-1
   do k=1,nz-1
      ielem=ielem+1
      face(ielem)=3
      icon(1,ielem)=2*nx*ny+2*ny*nz+(i-1)*nz+k
      icon(3,ielem)=icon(1,ielem)+1
      icon(2,ielem)=icon(1,ielem)+nz
      ielem=ielem+1
      face(ielem)=3
      icon(1,ielem)=icon(2,ielem-1)+1
      icon(3,ielem)=icon(2,ielem-1)
      icon(2,ielem)=icon(3,ielem-1)
   enddo
enddo

do i=1,nx-1
   do k=1,nz-1
      ielem=ielem+1
      face(ielem)=4
      icon(1,ielem)=2*nx*ny+2*ny*nz+nz*nx+(i-1)*nz+k
      icon(2,ielem)=icon(1,ielem)+1
      icon(3,ielem)=icon(1,ielem)+nz
      ielem=ielem+1
      face(ielem)=4
      icon(1,ielem)=icon(3,ielem-1)+1
      icon(2,ielem)=icon(3,ielem-1)
      icon(3,ielem)=icon(2,ielem-1)
   enddo
enddo

write(*,'(a,i6)') 'nb of triangles',ielem
nelem=ielem


do i=1,nelem
   if(face(i)==1) then
      i1=icon(1,i)
      i2=icon(2,i)
      i3=icon(3,i)
      write(1234,'(3f30.15)') x(i1),y(i1),z(i1)
      write(1234,'(3f30.15)') x(i2),y(i2),z(i2)
      write(1234,'(3f30.15)') x(i3),y(i3),z(i3)
   end if
end do



!================================
!=====[remove double points]=====
!================================

      i1=1
  111 continue
      do i=i1,inode
      do j=i+1,inode
      dist=(x(i)-x(j))**2+(y(i)-y(j))**2+(z(i)-z(j))**2
      if (dist.lt.1.d-10) then
        do ij=j+1,inode
        x(ij-1)=x(ij)
        y(ij-1)=y(ij)
        z(ij-1)=z(ij)
        enddo
        do ij=1,nelem
        do k=1,3
        if (icon(k,ij).eq.j) icon(k,ij)=i
        enddo
        enddo
        do ij=1,nelem
        do k=1,3
        if (icon(k,ij).gt.j) icon(k,ij)=icon(k,ij)-1
        enddo
        enddo
      inode=inode-1
      i1=i
      goto 111
      endif
      enddo
      enddo

nnode=inode

write(*,'(a,i6)') 'real nb of pts',nnode

!print*,minval(icon(:,1:nelem)),maxval(icon(:,1:nelem))

! add perturbation
!      call random_number (noise)
!      inode=0
!      do j=1,ny
!      do i=1,nx
!      inode=inode+1
!      z(inode)=z(inode)+dz*sin(x(inode)*wx*2.d0*pi)+dz*sin(y(inode)*wy*2.d0*pi)
!      z(inode)=z(inode)-dz*noise(inode)
!      enddo
!      enddo
!      do j=1,ny
!      do i=1,nx
!      inode=inode+1
!      z(inode)=z(inode)+dz*sin(x(inode)*wx*2.d0*pi)+dz*sin(y(inode)*wy*2.d0*pi)
!      z(inode)=z(inode)+dz*noise(inode)
!      enddo
!      enddo


!=====[compute normals]=====

xn=0.d0
yn=0.d0
zn=0.d0
do i=1,nelem
   i1=icon(1,i)
   i2=icon(2,i)
   i3=icon(3,i)
   if (i1.eq.i2 .and. i2.eq.i3) print*,'element ',i,' collapsed: ',icon(:,i)
   x1=x(i1)
   x2=x(i2)
   x3=x(i3)
   y1=y(i1)
   y2=y(i2)
   y3=y(i3)
   z1=z(i1)
   z2=z(i2)
   z3=z(i3)
   xne=(y2-y1)*(z3-z1)-(y3-y1)*(z2-z1)
   yne=(z2-z1)*(x3-x1)-(z3-z1)*(x2-x1)
   zne=(x2-x1)*(y3-y1)-(x3-x1)*(y2-y1)
   xyzn=sqrt(xne**2+yne**2+zne**2)
   xne=xne/xyzn
   yne=yne/xyzn
   zne=zne/xyzn
   do j=1,3
      ij=icon(j,i)
      xn(ij)=xn(ij)+xne
      yn(ij)=yn(ij)+yne
      zn(ij)=zn(ij)+zne
   enddo
enddo
do i=1,nnode
   xyzn=sqrt(xn(i)**2+yn(i)**2+zn(i)**2)
   xn(i)=xn(i)/xyzn
   yn(i)=yn(i)/xyzn
   zn(i)=zn(i)/xyzn
enddo

print *,count(face==0)
print *,count(face==1)
print *,count(face==2)
print *,count(face==3)
print *,count(face==4)
print *,count(face==5)
print *,count(face==6)

real_nelem = 0
if (flag1) real_nelem=real_nelem+count(face==1)
if (flag2) real_nelem=real_nelem+count(face==2)
if (flag3) real_nelem=real_nelem+count(face==3)
if (flag4) real_nelem=real_nelem+count(face==4)
if (flag5) real_nelem=real_nelem+count(face==5)
if (flag6) real_nelem=real_nelem+count(face==6)

print *,'nb of triangles that constitute the surface',real_nelem

!=====[construct the list of nodes that constitute the reak surface]=====

allocate(yesno_point(nnode))

yesno_point=.false.

do i=1,nelem
!   if ((face(i)==1 .and. flag1) .or. &
!       (face(i)==2 .and. flag2) .or. &
!       (face(i)==3 .and. flag3) .or. &
!       (face(i)==4 .and. flag4) .or. &
!       (face(i)==5 .and. flag5) .or. &
!       (face(i)==6 .and. flag6 )) then

if (face(i)==1) then

      i1=icon(1,i)
      i2=icon(2,i)
      i3=icon(3,i)
      yesno_point(i1)=.true.
      yesno_point(i2)=.true.
      yesno_point(i3)=.true.
   end if

end do
















real_nnode=count(yesno_point)
print *,'nb of pts that constitute the surface',real_nnode

allocate(real_x(real_nnode))
allocate(real_y(real_nnode))
allocate(real_z(real_nnode))

ie=0
do i=1,nnode
   if (yesno_point(i)) then
      ie=ie+1
      real_x(ie)=x(i)
      real_y(ie)=y(i)
      real_z(ie)=z(i)

     write (123,*) real_x(ie),real_y(ie),real_z(ie)

   end if
end do
stop

allocate (effect_num(nnodemax))

ie=0
do i=1,nnode

   if (yesno_point(i)) then 
      ie=ie+1
      effect_num(i)=ie
   end if

end do


!=====[construct real_icon]======
allocate(real_icon(3,real_nelem))

test=.false.

ie=0
do i=1,nelem
   if (face(i)==1) test=flag1
   if (face(i)==2) test=flag2
   if (face(i)==3) test=flag3
   if (face(i)==4) test=flag4
   if (face(i)==5) test=flag5
   if (face(i)==6) test=flag6

   if (test) then

      ie=ie+1
      real_icon(1,ie)=effect_num(icon(1,i))
      real_icon(2,ie)=effect_num(icon(2,i))
      real_icon(3,ie)=effect_num(icon(3,i))

   end if

end do

!=====[compute normals]=====

allocate(real_xn(real_nnode))
allocate(real_yn(real_nnode))
allocate(real_zn(real_nnode))

real_xn=0.d0
real_yn=0.d0
real_zn=0.d0
do i=1,real_nelem
   i1=real_icon(1,i)
   i2=real_icon(2,i)
   i3=real_icon(3,i)
   if (i1.eq.i2 .and. i2.eq.i3) print*,'element ',i,' collapsed: ',icon(:,i)
   x1=real_x(i1)
   x2=real_x(i2)
   x3=real_x(i3)
   y1=real_y(i1)
   y2=real_y(i2)
   y3=real_y(i3)
   z1=real_z(i1)
   z2=real_z(i2)
   z3=real_z(i3)
   xne=(y2-y1)*(z3-z1)-(y3-y1)*(z2-z1)
   yne=(z2-z1)*(x3-x1)-(z3-z1)*(x2-x1)
   zne=(x2-x1)*(y3-y1)-(x3-x1)*(y2-y1)
   xyzn=sqrt(xne**2+yne**2+zne**2)
   xne=xne/xyzn
   yne=yne/xyzn
   zne=zne/xyzn
   do j=1,3
      ij=real_icon(j,i)
      real_xn(ij)=real_xn(ij)+xne
      real_yn(ij)=real_yn(ij)+yne
      real_zn(ij)=real_zn(ij)+zne
   enddo
enddo
do i=1,real_nnode
   xyzn=sqrt(real_xn(i)**2+real_yn(i)**2+real_zn(i)**2)
   real_xn(i)=real_xn(i)/xyzn
   real_yn(i)=real_yn(i)/xyzn
   real_zn(i)=real_zn(i)/xyzn
enddo




!=====[produces real surface vtk file]=====

      open(unit=30,file='Mesh2.vtk')
      write(30,'(a)')'# vtk DataFile Version 3.0'
      write(30,'(a)')'surface'
      write(30,'(a)')'ASCII'
      write(30,'(a)')'DATASET UNSTRUCTURED_GRID'
      write(30,'(a7,i10,a6)')'POINTS ',real_nnode,' float'
!      do i=1,nnode
!         if(yesno_point(i)) write(30,'(3f16.11)') x(i),y(i),z(i)
!      enddo
      do i=1,real_nnode
         write(30,'(3f16.11)') real_x(i),real_y(i),real_z(i)
      enddo
      write(30,'(A6, 2I10)') 'CELLS ',real_nelem,4*real_nelem
      do i=1,real_nelem
      write(30,'(9I10)') 3, real_icon(1:3,i)-1
      enddo
      write(30,'(A11, I10)') 'CELL_TYPES ',real_nelem
      do i=1,real_nelem
      write(30,'(I2)') 5 ! octree  (8 nodes)
      enddo
      write(30,'(a11,i10)')'POINT_DATA ',real_nnode
      write(30,'(a)')'VECTORS norm float'
!      do i=1,nnode
!         if (yesno_point(i)) write(30,'(3f18.13)')xn(i),yn(i),zn(i)
!      enddo
      do i=1,real_nnode
         write(30,'(3f18.13)') real_xn(i),real_yn(i),real_zn(i)
      enddo
      close(30)




!=====[produce data file readable by DOUAR]=====

      open (71,file='surface-1.txt',status='unknown')
!      write (71,*) nnode,nelem
        do i=1,nnode
        write (71,*) x(i),y(i),z(i),xn(i),yn(i),zn(i)
        enddo
!        do i=1,nelem 
!        write (71,*) (icon(j,i),j=1,3)
!        enddo
      close (71)

!=====[produce vtk file of the surface]=====

      open(unit=30,file='Mesh.vtk')
      write(30,'(a)')'# vtk DataFile Version 3.0'
      write(30,'(a)')'surface'
      write(30,'(a)')'ASCII'
      write(30,'(a)')'DATASET UNSTRUCTURED_GRID'
      write(30,'(a7,i10,a6)')'POINTS ',nnode,' float'
      do i=1,nnode
      write(30,'(3f16.11)') x(i),y(i),z(i)
      enddo
      write(30,'(A6, 2I10)') 'CELLS ',nelem,4*nelem
      do i=1,nelem
      write(30,'(9I10)')3,icon(1:3,i)-1
      enddo
      write(30,'(A11, I10)') 'CELL_TYPES ',nelem
      do i=1,nelem
      write(30,'(I2)')5 ! octree  (8 nodes)
      enddo
      write(30,'(a11,i10)')'POINT_DATA ',nnode
      write(30,'(a)')'VECTORS norm float'
      do i=1,nnode
      write(30,'(3f18.13)')xn(i),yn(i),zn(i)
      enddo
      close(30)

      deallocate (x,y,z,icon,xn,yn,zn)
      end
